//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

//  Files-11 Structure level 2 

#ifndef __F11WINDOW_H__
#define __F11WINDOW_H__

#include "definitions.h"

// File content window.
// Represents a range of virtual blocks (vbn through vbn+cnt)
class file_window {
private:
    friend class f11_file;
    friend class f11_file_sequential;
    friend class f11_directory;
    friend class f11_file_bitmap_sys;
    friend class f11_file_indexf_sys;
    friend class f11_volume;
    friend class f11_volume_acp;

    ods_word_t*	p_content;
    dword_t	block_count;
    lbn_t*	p_block_lbn;
    long	start_vbn;	//must be dword_t when start_vbn can be initially 0!

    file_window(dword_t size) {
	block_count = size;
	start_vbn = -(long)size;
	if (size != 0) {
	    p_content = new ods_word_t[size * F11_BLOCK_SIZE / sizeof(ods_word_t)];
	    p_block_lbn = new lbn_t[size];
	} else {
	    p_content = NULL;
	    p_block_lbn = NULL;
	}
    }

    ~file_window() {
	delete[] p_content;
	p_content = NULL;
	delete[] p_block_lbn;
	p_block_lbn = NULL;
    }
};

#endif 	//__F11WINDOW_H__
